diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 874a85532..f4c5a0f09 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -11,18 +11,7 @@ import net.minecraft.client.entity.ClientSkinVariantList;
 import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
 import net.minecraft.client.enums.EnumGPUVendor;
-import net.minecraft.client.gui.ExceptionPopupElement;
-import net.minecraft.client.gui.MainMenuBackground;
-import net.minecraft.client.gui.Screen;
-import net.minecraft.client.gui.ScreenConnecting;
-import net.minecraft.client.gui.ScreenConsole;
-import net.minecraft.client.gui.ScreenGameOver;
-import net.minecraft.client.gui.ScreenMainMenu;
-import net.minecraft.client.gui.ScreenPause;
-import net.minecraft.client.gui.ScreenPhotoMode;
-import net.minecraft.client.gui.ScreenSleepSP;
-import net.minecraft.client.gui.ScreenStats;
-import net.minecraft.client.gui.TooltipElement;
+import net.minecraft.client.gui.*;
 import net.minecraft.client.gui.achievements.ScreenAchievements;
 import net.minecraft.client.gui.chat.ScreenChat;
 import net.minecraft.client.gui.chat.ScreenSleepMP;
@@ -33,6 +22,7 @@ import net.minecraft.client.gui.error.ScreenConflictWarning;
 import net.minecraft.client.gui.error.ScreenMissingMinecraft;
 import net.minecraft.client.gui.error.ScreenOutOfMemory;
 import net.minecraft.client.gui.hud.HudIngame;
+import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.gui.popup.PopupScreen;
@@ -1420,7 +1410,7 @@ public class Minecraft
                             GameSettings.FLIGHT_SPEED.value = newSpeed;
 
                             this.thePlayer.setFlySpeed(newSpeed);
-                            this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.FLIGHT_SPEED);
+                            HudComponents.DYNAMIC_TOOLTIP.setOptionNameAndValueString(GameSettings.FLIGHT_SPEED);
                         } else if (!GameSettings.KEY_ZOOM.isPressed()) {
                             this.thePlayer.inventory.changeCurrentSlot(scrollDelta);
                         }
@@ -1517,35 +1507,35 @@ public class Minecraft
                                         this.fullbright = !this.fullbright;
                                     }
                                 }
-                                this.hudIngame.heldItemTooltipElement.setString("Fullbright: " + (this.fullbright ? "On" : "Off"));
+                                HudComponents.DYNAMIC_TOOLTIP.setString("Fullbright: " + (this.fullbright ? "On" : "Off"));
                             } else if (GameSettings.KEY_LIGHTMAPS.isPressEvent()) {
                                 if (GameSettings.LIGHTMAP_STYLE.value == LightmapStyle.COLORIZED) {
                                     GameSettings.LIGHTMAP_STYLE.value = LightmapStyle.GRAY;
-                                    this.hudIngame.heldItemTooltipElement.setString("Lightmap: Gray");
+                                    HudComponents.DYNAMIC_TOOLTIP.setString("Lightmap: Gray");
                                 } else {
                                     GameSettings.LIGHTMAP_STYLE.value = LightmapStyle.COLORIZED;
-                                    this.hudIngame.heldItemTooltipElement.setString("Lightmap: Colored");
+                                    HudComponents.DYNAMIC_TOOLTIP.setString("Lightmap: Colored");
                                 }
                             } else if (GameSettings.KEY_COLLISION_BOXES.isPressEvent()) {
                                 GameSettings.SHOW_COLLISION_BOXES.toggle();
-                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.SHOW_COLLISION_BOXES);
+                                HudComponents.DYNAMIC_TOOLTIP.setOptionNameAndValueString(GameSettings.SHOW_COLLISION_BOXES);
                             } else if (GameSettings.KEY_CHUNK_BORDERS.isPressEvent()) {
                                 GameSettings.SHOW_CHUNK_BORDERS.toggle();
-                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.SHOW_CHUNK_BORDERS);
+                                HudComponents.DYNAMIC_TOOLTIP.setOptionNameAndValueString(GameSettings.SHOW_CHUNK_BORDERS);
                             } else if (GameSettings.KEY_CLEAR_CHAT.isPressEvent()) {
                                 this.hudIngame.clearChatMessages();
                             } else if (GameSettings.KEY_PAUSE_LOST_FOCUS.isPressEvent()) {
                                 GameSettings.PAUSE_ON_LOST_FOCUS.toggle();
-                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.PAUSE_ON_LOST_FOCUS);
+                                HudComponents.DYNAMIC_TOOLTIP.setOptionNameAndValueString(GameSettings.PAUSE_ON_LOST_FOCUS);
                             } else if (GameSettings.KEY_TOGGLE_ITEM_INFO.isPressEvent()) {
                                 GameSettings.SHOW_ITEM_DEBUG_INFO.toggle();
-                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.SHOW_ITEM_DEBUG_INFO);
+                                HudComponents.DYNAMIC_TOOLTIP.setOptionNameAndValueString(GameSettings.SHOW_ITEM_DEBUG_INFO);
                             } else if (GameSettings.KEY_RELOAD_CHUNKS.isPressEvent()) {
                                 this.renderGlobal.allChanged();
                             } else if (GameSettings.KEY_SMOOTH_LIGHTING.isPressEvent()) {
                                 GameSettings.AMBIENT_OCCLUSION.toggle();
                                 GameSettings.AMBIENT_OCCLUSION.onUpdate();
-                                this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.AMBIENT_OCCLUSION);
+                                HudComponents.DYNAMIC_TOOLTIP.setOptionNameAndValueString(GameSettings.AMBIENT_OCCLUSION);
                             }
                             if (!GameSettings.KEY_TOGGLE_DEBUG.isPressEvent()) this.f3Press = false;
                         } else if (GameSettings.KEY_RELEASE_CURSOR.isPressEvent()) {
@@ -1673,7 +1663,7 @@ public class Minecraft
         }
 
         // Toggle overlay
-        if (GameSettings.KEY_TOGGLE_OVERLAY.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_TOGGLE_INFO_OVERLAY.isPressEvent(currentInputDevice)) {
             if (control) {
                 GameSettings.OVERLAY_MODE.value++;
                 GameSettings.OVERLAY_MODE.value %= 3;
@@ -1708,7 +1698,7 @@ public class Minecraft
         // Cinematic camera
         if (GameSettings.KEY_CINEMATIC_CAMERA.isPressEvent(currentInputDevice)) {
             GameSettings.SMOOTH_CAMERA.value = !GameSettings.SMOOTH_CAMERA.value;
-            this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.SMOOTH_CAMERA);
+            HudComponents.DYNAMIC_TOOLTIP.setOptionNameAndValueString(GameSettings.SMOOTH_CAMERA);
             return true;
         }
 
@@ -1824,7 +1814,7 @@ public class Minecraft
             }
 
             GameSettings.RENDER_DISTANCE.set(nextRenderDistance);
-            this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.RENDER_DISTANCE);
+            HudComponents.DYNAMIC_TOOLTIP.setOptionNameAndValueString(GameSettings.RENDER_DISTANCE);
             return true;
         }
 
@@ -1842,7 +1832,7 @@ public class Minecraft
             }
             int newGammaStep = ((currentGammaStep + (shift ? -1 : 1)) + 5) % 5;
             GameSettings.GAMMA.value = newGammaStep * 0.25f;
-            this.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.GAMMA);
+            HudComponents.DYNAMIC_TOOLTIP.setOptionNameAndValueString(GameSettings.GAMMA);
             return true;
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java b/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
index 7dcd9bc0d..41619bdcd 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
@@ -213,13 +213,7 @@ public class ClientSkinVariantList extends SkinVariantList {
 			return this.variantEntries.length;
 		}
 
-		public static class VariantEntry {
-			public final String textureKey;
-			public final double weight;
-			public VariantEntry(final String key, final double weight) {
-				this.textureKey = key;
-				this.weight = weight;
-			}
+		public record VariantEntry(String textureKey, double weight) {
 		}
 	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 1a03d81b3..75279c62e 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -5,6 +5,8 @@ import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.hud.HudIngame;
+import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.enums.ParticlesQuality;
 import net.minecraft.client.render.particle.ParticlePickupAnimation;
@@ -457,7 +459,7 @@ public class PlayerLocal extends Player {
 
     @Override
     public void sendStatusMessage(String message) {
-        this.mc.hudIngame.heldItemTooltipElement.setString(message);
+        HudComponents.DYNAMIC_TOOLTIP.setString(message);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
index 2f19fb116..81c86c421 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
@@ -11,6 +11,8 @@ import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.util.helper.Time;
 import org.jetbrains.annotations.NotNull;
 
+/** @deprecated - replaced with HudComponentDynamicTooltip. All logic now belongs in the HudComponent **/
+@Deprecated
 public class HeldItemTooltipElement extends Gui {
 
     private int lastItemID;
@@ -26,28 +28,20 @@ public class HeldItemTooltipElement extends Gui {
 	private final double fadeTime = 0.5;
 	
 	public HeldItemTooltipElement() {}
-	
-	public void updateAndRender(Minecraft mc, int width, int height, int screenPadding) {
-		if(GameSettings.HELD_ITEM_TOOLTIPS.value) {
-			ItemStack item = mc.thePlayer.getCurrentEquippedItem();
-			
-			int id = getItemID(item);
-			int i = mc.thePlayer.inventory.getCurrentSlot();
-			
-			if(id != this.lastItemID || i != this.lastSelectedItem) {
-				updateString(item);
-
-                this.time = this.displayTime;
 
-                this.lastItemID = id;
-                this.lastSelectedItem = i;
-			}
-		}
-		
+	public void updateAndRender(Minecraft mc, int width, int height, int screenPadding) {
+		runChecksAndUpdate(mc);
 		render(mc, width, height, screenPadding);
 	}
+
+
 	public void updateAndRender(Minecraft mc, int x, int y) {
-		if(GameSettings.HELD_ITEM_TOOLTIPS.value) {
+		runChecksAndUpdate(mc);
+		render(mc, x, y);
+	}
+
+	private void runChecksAndUpdate(Minecraft mc) {
+		if(GameSettings.HIDE_DYNAMIC_TOOLTIP.value) {
 			ItemStack item = mc.thePlayer.getCurrentEquippedItem();
 
 			int id = getItemID(item);
@@ -56,16 +50,14 @@ public class HeldItemTooltipElement extends Gui {
 			if(id != this.lastItemID || i != this.lastSelectedItem) {
 				updateString(item);
 
-                this.time = this.displayTime;
+				this.time = this.displayTime;
 
-                this.lastItemID = id;
-                this.lastSelectedItem = i;
+				this.lastItemID = id;
+				this.lastSelectedItem = i;
 			}
 		}
-
-		render(mc, x, y);
 	}
-	
+
 	private void updateString(ItemStack item) {
 		if(item == null) {
             this.string = null;
